import { ApiCall, BaseConnection } from "tsrpc";
import Client from "../component/Client/Client";
import User from "../component/Client/User";
import Lobby from "../component/Lobby/Lobby";
import { ReqAccountLogin, ResAccountLogin } from "../shared/protocols/PtlAccountLogin";

export default async function (call: ApiCall<ReqAccountLogin, ResAccountLogin>) {
	// Error
	if (!call.req.name) {
		call.error('Name is empty')
		return;
	}

	// Success
	const { sn, req } = call
	const { name } = req
	const conn: BaseConnection<any> = call.conn
	console.log(`name: ${name} is Login`)
	const user = new User(name)
	const client = new Client(conn, sn)
	client.setUser(user)
	Lobby.AddClient(client)
	call.succ(0)
}